如何使用 Inventor API 和 Python 访问装配中出现的工作平面

问题描述

我想在 Inventor 组件中使用 Inventor API 和 Python 在组件的基本坐标系的平面之间添加约束。组件的放置有效。我的问题是,我无法在个人事件的定义中访问工作平面。 我的代码如下所示:

import win32com.client as win32
project_folder = "C:\\Users\\User_1\\210608_project\\"

#initialization
inv = win32.gencache.EnsureDispatch('Inventor.Application')
inv.Visible = True

#Open a new assembly
inv.Documents.Add(win32.constants.kAssemblyDocumentObject,"",True)
invActDoc = inv.ActiveDocument
invAssDoc = win32.CastTo(invActDoc,'AssemblyDocument')


#Create the transient matrices
oTG = inv.TransientGeometry
oMatrix = oTG.CreateMatrix()

#Add component to assembly
invAssDocDef = invAssDoc.ComponentDefinition
invAssOcc = invAssDocDef.Occurrences
occ1 = invAssOcc.Add(project_folder + 'generic_part_1.ipt',oMatrix)
occ2 = invAssOcc.Add(project_folder + 'generic_part_2.ipt',oMatrix)


#create constraints
#get the Planes of the Base-Coordinate-System of Part 1
wp_YZ_1 = occ1.Definition.WorkPlanes.Item(1)
wp_XZ_1 = occ1.Definition.WorkPlanes.Item(2)
wp_XY_1 = occ1.Definition.WorkPlanes.Item(3)

#get the Planes of the Base-Coordinate-System of Part 2
wp_YZ_2 = occ2.Definition.WorkPlanes.Item(1)
wp_XZ_2 = occ2.Definition.WorkPlanes.Item(2)
wp_XY_2 = occ2.Definition.WorkPlanes.Item(3)

#Add the constraints
AssCons = invAssDoc.ComponentDefinition.Constraints
AssCons.AddFlushConstraint(wp_YZ_1,wp_YZ_2,0)
AssCons.AddFlushConstraint(wp_XZ_1,wp_XZ_2,0)
AssCons.AddFlushConstraint(wp_XY_1,wp_XY_2,0)

当我尝试获取工作平面时它会中断:

Traceback (most recent call last):
  File "C:/Users/User1/210608_projekt/how_to_constrain_components_in_assemblies.py",line 27,in <module>
    wp1 = occ1.Definition.WorkPlanes.Item(1)
  File "C:\Program Files\Python37\lib\site-packages\win32com\client\__init__.py",line 473,in __getattr__
    raise AttributeError("'%s' object has no attribute '%s'" % (repr(self),attr))
AttributeError: '<win32com.gen_py.Autodesk Inventor Object Library.ComponentDefinition instance at 0x2748634277928>' object has no attribute 'WorkPlanes'

这发生在我尝试过的所有事情上,即在 Occurrence.Item(i).Definition 中。

如果我在 VBA 脚本中打开同一个程序集,一切都应该在那里。我是否遗漏了有关使用 API 处理事件的内容?

解决方法

您需要创建 WorkPlaneProxyWorkPlane 对象。它意味着在装配中特定发生的上下文中部分定义的工作平面的表示

这是 VB.NET 代码的一部分

'Define variables for workplane proxy
Dim wp_YZ_1_proxy As WorkPlaneProxy
Dim wp_YZ_2_proxy As WorkPlaneProxy

'You need to pass result variable as argument
' ByRef in VB.NET,out in C#
'I don't know how to do in Python 
occ1.CreateGeometryProxy(wp_YZ_1,wp_YZ_1_proxy)
occ2.CreateGeometryProxy(wp_YZ_2,wp_YZ_2_proxy)

Dim AssCons As AssemblyConstraints = asm.Constraints

'Use this proxies for constraint creation
AssCons.AddFlushConstraint(wp_YZ_1_proxy,wp_YZ_2_proxy,0)

,

所以这就是最后 3 个块的解决方案/替换的样子:

#cast the definitions to PartComponentDefinition
occ1_def = win32.CastTo(occ1.Definition,'PartComponentDefinition')
occ2_def = win32.CastTo(occ2.Definition,'PartComponentDefinition')

#create constraints
#get the Planes of the Base-Coordinate-System of Part 1
wp_YZ_1 = occ1_def.WorkPlanes.Item(1)
wp_XZ_1 = occ1_def.WorkPlanes.Item(2)
wp_XY_1 = occ1_def.WorkPlanes.Item(3)

#create Geometry-Proxys for Workplanes of Comp1
wp_YZ_1_proxy = occ1.CreateGeometryProxy(wp_YZ_1)
wp_XZ_1_proxy = occ1.CreateGeometryProxy(wp_XZ_1)
wp_XY_1_proxy = occ1.CreateGeometryProxy(wp_XY_1)


#get the Planes of the Base-Coordinate-System of Part 2
wp_YZ_2 = occ2_def.WorkPlanes.Item(1)
wp_XZ_2 = occ2_def.WorkPlanes.Item(2)
wp_XY_2 = occ2_def.WorkPlanes.Item(3)

#create Geometry-Proxys for Workplanes of Comp2
wp_YZ_2_proxy = occ2.CreateGeometryProxy(wp_YZ_2)
wp_XZ_2_proxy = occ2.CreateGeometryProxy(wp_XZ_2)
wp_XY_2_proxy = occ2.CreateGeometryProxy(wp_XY_2)

#Add the constraints
AssCons = invAssDoc.ComponentDefinition.Constraints
AssCons.AddFlushConstraint(wp_YZ_1_proxy,0)
AssCons.AddFlushConstraint(wp_XZ_1_proxy,wp_XZ_2_proxy,0)
AssCons.AddFlushConstraint(wp_XY_1_proxy,wp_XY_2_proxy,0)

相关问答

错误1:Request method ‘DELETE‘ not supported 错误还原:...
错误1:启动docker镜像时报错:Error response from daemon:...
错误1:private field ‘xxx‘ is never assigned 按Alt...
报错如下,通过源不能下载,最后警告pip需升级版本 Requirem...